// *******************   RM_LIB v1.0 **********************  //
{=                      URM_WavUtils                         =}
{=            -               =}
{=      Copyright (c) 2003-2006  ReMax SoftWare 2000         =}
{=   1.6                                               =}
{=                                               =}
{=   : 13/01/2006                        =}
{=                                                           =}
{=                                                           =}
{=     WavUtils BaseGroup Labs  Delphi4  =}
{=                                                           =}
{=   :                                                =}
{=  v1.0     10.10.2003                                      =}
{=        Delphi7   ReMax  =}
{=                                                           =}
{=  v1.1     15.09.2004                                      =}
{=               =}
{=                                                           =}
{=  v1.2     17.09.2004                                      =}
{=         ( 2-4)                   =}
{=                                                           =}
{=  v1.3     22.12.2005                                      =}
{=         ( 5-8)                   =}
{=                                                           =}
{=  v1.4     7.01.2006                                       =}
{=         ( 1-5)                  =}
{=                                                           =}
{=  v1.5     9.01.2006                                       =}
{=          ( 11-20)         =}
{=                                                           =}
{=  v1.6    13.01.2006                                       =}
{=          ( 21-32)         =}
{=         GetMaxLevelForWavelets                =}
{=                                                           =}


unit Wavelets;

interface

type
  TVector = array of Double;   //     

  TDecomposition = record      //   
    WaveletMode:integer;       //  : 0-; 1-; 2-.
    WaveletOrder: Integer;     //  
    SignalLength: Integer;     //   
    Approx: TVector;           //      
    Details: array of TVector; //      
                               //     
  end;
var
  wave_error:integer;


//      .
//     Signal  
//    Order   Level.
//   - ,  
//      ,
//      ,
//      
// (   ).
function Decompose(
  const Signal: TVector;      //  
  const Mode: Integer;        //  
  const Order: Integer;       //  
  const Level: Integer        //  
  ): TDecomposition;          //  

//  .
//      Decomp.
//   -   .
//       
//  .
function Reconstruct(
  const Decomp: TDecomposition //  
  ): TVector;                  //  

//       -.
//      Signal  
//    Order.   - ,
//       Level.
function Denoise(
  const Signal: TVector; //  
  const Mode: Integer;   //  
  const Order: Integer;  //  
  const Level: Integer   //  
  ): TVector;            //  
  overload;

//       -.
//     
//    .
function Denoise(
  const Decomp: TDecomposition //   
  ): TVector;                  //  
  overload;

//      
function GetMinOrderForWavelets(wmode:integer):integer;

//      
function GetMaxOrderForWavelets(wmode:integer):integer;

//   -  Wavelet
// ( wmode   worder)    (Signal)
function GetMaxLevelForWavelets(wmode,worder:integer;Signal: TVector):integer; overload;
function GetMaxLevelForWavelets(wmode,worder,SizeX:integer):integer; overload;

//   
function GetNameWavelets(wmode:integer):string;

implementation

uses math;

type
  PDouble = ^Double;

const
  //  
  NWaveletsDB  = 32;
  NWaveletsSYM =  8;
  NWaveletsCOIF=  5;

  //  
  MWaveletsDB  =  1;
  MWaveletsSYM =  2;
  MWaveletsCOIF=  1;

  //   
  WaveletsEnName :array[0..2] of string= ('Daubechies','Symlets','Coiflets');
  WaveletsRusName:array[0..2] of string= ('','','');

  MinOrder :array[0..2] of integer    = (MWaveletsDB,MWaveletsSYM,MWaveletsCOIF);
  MaxOrder :array[0..2] of integer    = (nWaveletsDB,nWaveletsSYM,nWaveletsCOIF);
  StartWave:array[0..2] of integer    = (1,nWaveletsDB-MWaveletsDB+2,
                            nWaveletsDB-MWaveletsDB+3+nWaveletsSYM-MWaveletsSYM);


  Coiflets1: array [0..5] of Double =
  ( -5.142972847100000e-002,  2.389297284710000e-001,  6.028594569420001e-001,
     2.721405430580000e-001, -5.142972847100000e-002, -1.107027152900000e-002);

  Coiflets2: array [0..11] of Double =
  (  1.158759673900000e-002, -2.932013798000000e-002, -4.763959031000000e-002,
     2.730210465350000e-001,  5.746823938570000e-001,  2.948671936960000e-001,
    -5.408560709200000e-002, -4.202648046100000e-002,  1.674441016300000e-002,
     3.967883613000000e-003, -1.289203356000000e-003, -5.095053990000000e-004);

  Coiflets3: array [0..17] of Double =
  ( -2.682418671000000e-003,  5.503126709000000e-003,  1.658356047900000e-002,
    -4.650776447900000e-002, -4.322076356000000e-002,  2.865033352740000e-001,
     5.612852568700000e-001,  3.029835717730000e-001, -5.077014075500000e-002,
    -5.819625076200000e-002,  2.443409432100000e-002,  1.122924096200000e-002,
    -6.369601011000000e-003, -1.820458916000000e-003,  7.902051010000000e-004,
     3.296651740000000e-004, -5.019277500000000e-005, -2.446573400000000e-005);

  Coiflets4: array [0..23] of Double =
  (  6.309610460000000e-004, -1.152224852000000e-003, -5.194524026000000e-003,
     1.136245924400000e-002,  1.886723537800000e-002, -5.746423442900000e-002,
    -3.965264851700000e-002,  2.936673908950000e-001,  5.531264525620000e-001,
     3.071573261980000e-001, -4.711273886500000e-002, -6.803812705100000e-002,
     2.781364015300000e-002,  1.773583743800000e-002, -1.075631851700000e-002,
    -4.001012886000000e-003,  2.652665946000000e-003,  8.955945290000001e-004,
    -4.165005710000000e-004, -1.838297690000000e-004,  4.408035400000000e-005,
     2.208285700000000e-005, -2.304942000000000e-006, -1.262175000000000e-006);

   Coiflets5: array [0..29] of Double =
  ( -1.499638000000000e-004,  2.535612000000000e-004,  1.540245700000000e-003,
    -2.941110800000000e-003, -7.163781900000000e-003,  1.655206640000000e-002,
     1.991780430000000e-002, -6.499726280000000e-002, -3.680007360000000e-002,
     2.980923235000000e-001,  5.475054294000000e-001,  3.097068490000000e-001,
    -4.386605080000000e-002, -7.465223890000000e-002,  2.919587950000000e-002,
     2.311077700000000e-002, -1.397368790000000e-002, -6.480090000000000e-003,
     4.783001400000000e-003,  1.720654700000000e-003, -1.175822200000000e-003,
    -4.512270000000000e-004,  2.137298000000000e-004,  9.937760000000000e-005,
    -2.923210000000000e-005, -1.507200000000000e-005,  2.640800000000000e-006,
     1.459300000000000e-006, -1.184000000000000e-007, -6.730000000000000e-008);

  Symlets2: array [0..3] of Double =
  (  3.415063509462200e-001, 5.915063509458700e-001, 1.584936490537800e-001,
    -9.150635094586999e-002);

  Symlets3: array [0..5] of Double =
  (  2.352336038927000e-001,  5.705584579173100e-001,  3.251825002637100e-001,
    -9.546720778426000e-002, -6.041610415535000e-002,  2.490874986589000e-002);

  Symlets4: array [0..7] of Double =
  (  2.278517294800000e-002, -8.912350720850001e-003, -7.015881208950001e-002,
     2.106172671020000e-001,  5.683291217050001e-001,  3.518695343280000e-001,
    -2.095548256255000e-002, -5.357445070900000e-002);

  Symlets5: array [0..9] of Double =
  (  1.381607647893000e-002, -1.492124993438000e-002, -1.239756813067500e-001,
     1.173946156807000e-002,  4.482908241909200e-001,  5.115264834460500e-001,
     1.409953484272900e-001, -2.767209305836000e-002,  2.087343221079000e-002,
     1.932739797744000e-002);

  Symlets6: array [0..11] of Double =
  ( -5.515933754690000e-003,  1.249961046390000e-003,  3.162528132994000e-002,
    -1.489187564922000e-002, -5.136248493090000e-002,  2.389521856660500e-001,
     5.569463919639600e-001,  3.472289864783500e-001, -3.416156079324000e-002,
    -8.343160770584000e-002,  2.468306185920000e-003,  1.089235016328000e-002);

  Symlets7: array [0..13] of Double =
  (  7.260697381010000e-003,  2.835671342880000e-003, -7.623193594814000e-002,
    -9.902835340368001e-002,  2.040919698628700e-001,  5.428913549059901e-001,
     3.790813009826900e-001,  1.233282974432000e-002, -3.503914561106000e-002,
     4.800738396784000e-002,  2.157772629104000e-002, -8.935215825569999e-003,
    -7.406129573000000e-004,  1.896329267100000e-003);

  Symlets8: array [0..15] of Double =
  (  1.336396696400000e-003, -2.141971501200000e-004, -1.057284326418000e-002,
     2.693194376880000e-003,  3.474523295559000e-002, -1.924676063167000e-002,
    -3.673125438038000e-002,  2.576993351865400e-001,  5.495533152690100e-001,
     3.403726735943900e-001, -4.332680770282000e-002, -1.013243276428200e-001,
     5.379305875240000e-003,  2.241181152181000e-002, -3.833454481100000e-004,
    -2.391729255750000e-003);

  Daubechies1: array [0..1] of Double =
  (  0.50000000000000,  0.50000000000000 );

  Daubechies2: array [0..3] of Double =
  (  0.34150635094622,  0.59150635094587,  0.15849364905378, -0.09150635094587 );

  Daubechies3: array [0..5] of Double =
  (  0.23523360389270,  0.57055845791731,  0.32518250026371, -0.09546720778426,
    -0.06041610415535,  0.02490874986589 );

  Daubechies4: array [0..7] of Double =
  (  0.16290171402562,  0.50547285754565,  0.44610006912319, -0.01978751311791,
    -0.13225358368437,  0.02180815023739,  0.02325180053556, -0.00749349466513 );

  Daubechies5: array [0..9] of Double =
  (  0.11320949129173,  0.42697177135271,  0.51216347213016,  0.09788348067375,
    -0.17132835769133, -0.02280056594205,  0.05485132932108, -0.00441340005433,
    -0.00889593505093,  0.00235871396920 );

  Daubechies6: array [0..11] of Double =
  (  0.07887121600143,  0.34975190703757,  0.53113187994121,  0.22291566146505,
    -0.15999329944587, -0.09175903203003,  0.06894404648720,  0.01946160485396,
    -0.02233187416548,  0.00039162557603,  0.00337803118151, -0.00076176690258 );

  Daubechies7: array [0..13] of Double =
  (  0.05504971537285,  0.28039564181304,  0.51557424581833,  0.33218624110566,
    -0.10175691123173, -0.15841750564054,  0.05042323250485,  0.05700172257986,
    -0.02689122629486, -0.01171997078235,  0.00887489618962,  0.00030375749776,
    -0.00127395235906,  0.00025011342658 );

  Daubechies8: array [0..15] of Double =
  (  0.03847781105406,  0.22123362357624,  0.47774307521438,  0.41390826621166,
    -0.01119286766665, -0.20082931639111,  0.00033409704628,  0.09103817842345,
    -0.01228195052300, -0.03117510332533,  0.00988607964808,  0.00618442240954,
    -0.00344385962813, -0.00027700227421,  0.00047761485533, -0.00008306863060 );

  Daubechies9: array [0..17] of Double =
  (  0.02692517479416,  0.17241715192471,  0.42767453217028,  0.46477285717278,
     0.09418477475112, -0.20737588089628, -0.06847677451090,  0.10503417113714,
     0.02172633772990, -0.04782363205882,  0.00017744640673,  0.01581208292614,
    -0.00333981011324, -0.00302748028715,  0.00130648364018,  0.00016290733601,
    -0.00017816487955,  0.00002782275679 );

  Daubechies10: array [0..19] of Double =
  (  0.01885857879640,  0.13306109139687,  0.37278753574266,  0.48681405536610,
     0.19881887088440, -0.17666810089647, -0.13855493935993,  0.09006372426666,
     0.06580149355070, -0.05048328559801, -0.02082962404385,  0.02348490704841,
     0.00255021848393, -0.00758950116768,  0.00098666268244,  0.00140884329496,
    -0.00048497391996, -0.00008235450295,  0.00006617718320, -0.00000937920789 );

  Daubechies11: array [0..21] of Double =
  (  1.321886471665671e-002,  1.018707676009524e-001,  3.181271742303895e-001,
     4.848537683131794e-001,  2.913027988903021e-001, -1.147459261776472e-001,
    -1.939104913955001e-001,  4.669986906776616e-002,  1.059330899181801e-001,
    -3.286629145225294e-002, -4.697931589875155e-002,  2.215725478297950e-002,
     1.473674479914380e-002, -1.086456905449218e-002, -2.362343964095715e-003,
     3.484917545118889e-003, -2.182081030939380e-004, -6.314627963033724e-004,
     1.761774389539438e-004,  3.849423888144428e-005, -2.449063218490608e-005,
     3.177931817946238e-006);

  Daubechies12: array [0..23] of Double =
  (  9.271766518224147e-003,  7.747505450119439e-002,  2.668303750255331e-001,
     4.647096733229590e-001,  3.647868272187514e-001, -3.165284709804359e-002,
    -2.235719287136705e-001, -1.681447405734699e-002,  1.290318596728590e-001,
     3.789788060979821e-003, -6.818780604443028e-002,  7.671493573871450e-003,
     2.937765454983371e-002, -8.639889614157018e-003, -9.079834573749333e-003,
     4.745746461045988e-003,  1.590005428332863e-003, -1.541141788352285e-003,
     4.628104542807647e-006,  2.748192162496005e-004, -6.258185578399508e-005,
    -1.714136139124017e-005,  9.034669557219847e-006, -1.081217009051069e-006);

  Daubechies13: array [0..25] of Double =
  (  6.506891026784276e-003,  5.859174744008021e-002,  2.206147151049023e-001,
     4.320817360380838e-001,  4.164078086219348e-001,  6.150819684806092e-002,
    -2.227194789327630e-001, -8.808905109194988e-002,  1.269087528252593e-001,
     5.158268566903580e-002, -7.481728432187884e-002, -1.873013184153418e-002,
     3.969660494988322e-002,  1.682894519886790e-003, -1.685135918957518e-002,
     2.774645607425271e-003,  5.130476467389390e-003, -1.952966163061051e-003,
    -9.303219449292522e-004,  6.592541294136315e-004,  3.482608740057064e-005,
    -1.167638275787793e-004,  2.169300195922697e-005,  7.383559915721582e-006,
    -3.323696366957008e-006,  3.691122216149176e-007);

  Daubechies14: array [0..27] of Double =
  (  4.568725425915114e-003,  4.409854388947374e-002,  1.802063525433704e-001,
     3.919532612958064e-001,  4.463172083045974e-001,  1.546235261610520e-001,
    -1.921128176870549e-001, -1.541729875842814e-001,  9.786019420757498e-002,
     9.898718291852027e-002, -6.134039007700147e-002, -5.059275162371889e-002,
     3.905854655114523e-002,  1.907873678047559e-002, -2.134426676672519e-002,
    -3.970439599625684e-003,  9.043537416557383e-003, -5.276565075644391e-004,
    -2.722105748698456e-003,  7.507289661577507e-004,  5.006465593834608e-004,
    -2.735314931245886e-004, -2.954097378352807e-005,  4.861715681159335e-005,
    -7.309510712953861e-006, -3.103990103457436e-006,  1.219755432463267e-006,
    -1.263698790522480e-007);

  Daubechies15: array [0..29] of Double =
  (  3.209230545040773e-003,  3.305257150435392e-002,  1.456808713114518e-001,
     3.483432664027495e-001,  4.566588509260874e-001,  2.397109916594546e-001,
    -1.366159572709416e-001, -2.042708429992777e-001,  4.616201865524234e-002,
     1.344540308947735e-001, -2.804822242632716e-002, -7.857436740369972e-002,
     2.395475819556249e-002,  3.873569879545010e-002, -1.822002561281381e-002,
    -1.471492759181698e-002,  1.066594072434618e-002,  3.606951945679506e-003,
    -4.587521102137498e-003, -1.709476540136532e-004,  1.374137564570479e-003,
    -2.640919052642503e-004, -2.542510225676852e-004,  1.102354651860355e-004,
     1.823819247783110e-005, -1.989324456685141e-005,  2.377991041249956e-006,
     1.280761588017242e-006, -4.466710328588147e-007,  4.336940386156001e-008);

  Daubechies16: array [0..31] of Double =
  (  2.255119743014517e-003,  2.468348151398230e-002,  1.167180741866199e-001,
     3.042770443551345e-001,  4.506789844484508e-001,  3.113322263345836e-001,
    -6.346360393535744e-002, -2.312686847515197e-001, -1.974115428942410e-002,
     1.493343718134611e-001,  1.933248589902404e-002, -9.361266861385269e-002,
    -4.412150270918065e-003,  5.368654216336072e-002, -5.366215238420697e-003,
    -2.608403615488922e-002,  7.281544962481819e-003,  9.895088855141430e-003,
    -4.942686698382494e-003, -2.576894832903276e-003,  2.211846544558113e-003,
     2.884267211832856e-004, -6.654028602162096e-004,  8.078095351235175e-005,
     1.235932463637006e-004, -4.315894560625037e-005, -9.861077109740486e-006,
     8.016192860043622e-006, -7.379163728001773e-007, -5.206891647320802e-007,
     1.632556884111917e-007, -1.491528356269169e-008);

  Daubechies17: array [0..33] of Double =
  (  1.585196932543948e-003,  1.837444809961030e-002,  9.278294792164048e-002,
     2.618775084655140e-001,  4.320398502323538e-001,  3.665045915603217e-001,
     1.931460080008882e-002, -2.321578275722080e-001, -8.951954328826482e-002,
     1.395196558813297e-001,  7.151359021606081e-002, -8.967223561712207e-002,
    -4.036972996898634e-002,  5.735059315804640e-002,  1.577720421570927e-002,
    -3.317917437481259e-002, -2.312914840344462e-003,  1.607513687377304e-002,
    -2.151718850925759e-003, -6.083184145052887e-003,  2.098690587104339e-003,
     1.627197831622570e-003, -1.016003058543418e-003, -2.320247296028694e-004,
     3.107489840719602e-004, -1.810908214143659e-005, -5.801671982752155e-005,
     1.639555327119318e-005,  4.943101361114091e-006, -3.186182481278841e-006,
     2.133022685011471e-007,  2.091410386668801e-007, -5.956631070530590e-008,
     5.138893560292209e-009);

  Daubechies18: array [0..35] of Double =
  (  1.114619644713289e-003,  1.363905158127794e-002,  7.324810663575845e-002,
     2.225116133160550e-001,  4.043426134360905e-001,  4.043248276655230e-001,
     1.041024608213418e-001, -2.076447635276902e-001, -1.530751364326884e-001,
     1.057364881400040e-001,  1.181443292643340e-001, -6.528850140299068e-002,
    -7.548523752027639e-002,  4.588219059559975e-002,  4.034132415099365e-002,
    -3.148473687967226e-002, -1.678191401015531e-002,  1.885903701978224e-002,
     4.428021425574181e-003, -9.228790681742583e-003,  8.388410148926137e-005,
     3.495471785216499e-003, -7.910634551395130e-004, -9.479447333773161e-004,
     4.443923461708481e-004,  1.510249707640531e-004, -1.404657384123647e-004,
    -1.086057413038875e-007,  2.645454675504155e-005, -6.024975834024775e-006,
    -2.356528439236826e-006,  1.250668944695920e-006, -5.438805633415365e-008,
    -8.316274135109333e-008,  2.169994649108048e-008, -1.773377459865819e-009);

  Daubechies19: array [0..37] of Double =
  (  7.839479076430616e-004,  1.009826155733838e-002,  5.747230505211265e-002,
     1.869508529514531e-001,  3.708325188065387e-001,  4.254693669593039e-001,
     1.844805901970761e-001, -1.612849715802321e-001, -2.021184348398571e-001,
     5.278712614155708e-002,  1.501539434751162e-001, -2.370118827482901e-002,
    -1.009647332186763e-001,  1.950508138179294e-002,  6.145235618434579e-002,
    -1.873920386234179e-002, -3.229655512605244e-002,  1.529031257021874e-002,
     1.370058271592041e-002, -9.891284492474112e-003, -4.148540529632712e-003,
     4.978560207872192e-003,  5.437328418315161e-004, -1.900386103079033e-003,
     2.416952167251234e-004,  5.202909518628442e-004, -1.843258632324628e-004,
    -8.810606477668509e-005,  6.159798420121745e-005,  3.610452213799333e-006,
    -1.176638149987355e-005,  2.129073285965568e-006,  1.083239135482490e-006,
    -4.852701063239904e-007,  1.023245949056646e-008,  3.278810145199259e-008,
    -7.894154721325136e-009,  6.128387585580227e-010);

  Daubechies20: array [0..39] of Double =
  (  5.515104892384307e-004,  7.459548476764727e-003,  4.484738525140031e-002,
     1.555225599617243e-001,  3.342466780765652e-001,  4.316839091248781e-001,
     2.556207268547948e-001, -9.843781145673683e-002, -2.310731625907772e-001,
    -1.182783757312782e-002,  1.614261501196963e-001,  2.817837950196181e-002,
    -1.099259368211666e-001, -1.747743622120557e-002,  7.233116828744737e-002,
     3.982599945634670e-003, -4.364468087994824e-002,  4.154027345886258e-003,
     2.283551819145843e-002, -6.214991256279937e-003, -9.765516683795977e-003,
     4.752908245767341e-003,  3.125795498208468e-003, -2.532498877908461e-003,
    -5.880032514666376e-004,  9.846883499959784e-004, -3.782851465120471e-005,
    -2.723101792800023e-004,  7.179459484508218e-005,  4.790139911399602e-005,
    -2.623780652480648e-005, -3.094401000430759e-006,  5.120335768501894e-006,
    -7.155878270093904e-007, -4.841616414395223e-007,  1.862465681539380e-007,
     1.424340762353621e-010, -1.283287967671833e-008,  2.868114946353909e-009,
    -2.120497617493507e-010);

  Daubechies21: array [0..41] of Double =
  (  3.880761183901994e-004,  5.498914208838778e-003,  3.482343321346864e-002,
     1.282406209841787e-001,  2.967641918531107e-001,  4.253290386596589e-001,
     3.143729234132918e-001, -2.525991870550204e-002, -2.373503539112458e-001,
    -7.947673149275923e-002,  1.495987121835900e-001,  8.148224674579864e-002,
    -9.895282343446360e-002, -5.782432382234466e-002,  6.830679106166157e-002,
     3.233133026183716e-002, -4.594603433832595e-002, -1.319027033944802e-002,
     2.809111472522193e-002,  2.374292312744623e-003, -1.477291282871111e-002,
     1.699510586890884e-003,  6.356058675876645e-003, -2.044482124302372e-003,
    -2.091886344078316e-003,  1.213824479157975e-003,  4.521371577653060e-004,
    -4.883782304548200e-004, -2.260200554056991e-005,  1.369415875887744e-004,
    -2.570701021974115e-005, -2.474637549895798e-005,  1.085750094721010e-005,
     1.973061646488851e-006, -2.184972091063581e-006,  2.238767557213774e-007,
     2.115760101668473e-007, -7.073902454776599e-008, -1.593829273510538e-009,
     4.990783378917976e-009, -1.040828794769455e-009,  7.345464636157261e-011);

  Daubechies22: array [0..43] of Double =
  (  2.731293503077964e-004,  4.045962210741964e-003,  2.691951077895743e-002,
     1.049116942703760e-001,  2.600234456990306e-001,  4.090137065532137e-001,
     3.591403053475734e-001,  5.213109472604506e-002, -2.211310856760518e-001,
    -1.418232800472703e-001,  1.160314060555378e-001,  1.272602616600067e-001,
    -6.866770408130909e-002, -9.317414370209216e-002,  4.813722354471875e-002,
     5.979109422819047e-002, -3.632001252284176e-002, -3.290225257525906e-002,
     2.614233635361069e-002,  1.455700056775000e-002, -1.660286817107685e-002,
    -4.393807988447537e-003,  8.884602406089496e-003,  2.122291899158854e-004,
    -3.857756799472308e-003,  7.384038499336175e-004,  1.291891510726897e-003,
    -5.449608239070554e-004, -2.996629442023225e-004,  2.323619451549353e-004,
     3.073015293143851e-005, -6.650497410550639e-005,  8.042879778059755e-006,
     1.228510135937755e-005, -4.360536117353112e-006, -1.106748777992085e-006,
     9.158320155928746e-007, -6.208312596397059e-008, -9.074557498841245e-008,
     2.659590354225034e-008,  1.188060593965569e-009, -1.930135037049616e-009,
     3.773078524761877e-010, -2.547078871355881e-011);

  Daubechies23: array [0..45] of Double =
  (  1.922652995034436e-004,  2.971792242029590e-003,  2.072530234333678e-002,
     8.521734976375450e-002,  2.251787299523922e-001,  3.853245099456831e-001,
     3.896289301057240e-001,  1.282639554535442e-001, -1.848321604235035e-001,
    -1.919102643560166e-001,  6.514250006849588e-002,  1.580904498397689e-001,
    -2.336100287328858e-002, -1.159735176471370e-001,  1.434229957721935e-002,
     7.940600105229896e-002, -1.493848801612942e-002, -4.964412267128523e-002,
     1.539078496620196e-002,  2.722031066941049e-002, -1.309810211663791e-002,
    -1.240060304550928e-002,  9.016986023721241e-003,  4.265155423689017e-003,
    -5.003006239716251e-003, -8.024710733056003e-004,  2.208207113752331e-003,
    -1.743028122466961e-004, -7.504037985224956e-004,  2.258643963847206e-004,
     1.815584709488143e-004, -1.060814677162124e-004, -2.389239450348912e-005,
     3.129704961720878e-005, -1.863373368450643e-006, -5.902839422619092e-006,
     1.695337684954912e-006,  5.761205415964968e-007, -3.775246926859065e-007,
     1.310333767800173e-008,  3.830785762309281e-008, -9.899038820595946e-009,
    -6.698341858656222e-010,  7.427778106909503e-010, -1.366416758225364e-010,
     8.840272329646493e-012);

  Daubechies24: array [0..47] of Double =
  (  1.353655529852464e-004,  2.179360880351757e-003,  1.589741503225650e-002,
     6.877478649778430e-002,  1.929757451597756e-001,  3.566441831418293e-001,
     4.065434219267473e-001,  1.986867900678875e-001, -1.324208817048394e-001,
     -2.248197071477030e-001, 3.377575926292167e-003,  1.691663798861050e-001,
     3.007235311842202e-002, -1.210392517015579e-001, -2.741960238356013e-002,
     8.557144880854636e-002,  1.483518068600379e-002, -5.809706280991427e-002,
    -3.237443284716394e-003,  3.627572343967132e-002, -3.496437538263706e-003,
    -1.994967931782517e-002,  5.417655513756575e-003,  9.227722905944055e-003,
    -4.448716606864934e-003, -3.356330972753420e-003,  2.641783588084500e-003,
     8.158350109373401e-004, -1.199576120364919e-003, -3.122714257177887e-005,
     4.144544181959795e-004, -8.352580326008639e-005, -1.032432340036292e-004,
     4.638188186193615e-005,  1.543784841253681e-005, -1.430398029054291e-005,
     9.483417246085270e-009,  2.758494502930454e-006, -6.349997893668460e-007,
    -2.851413579524286e-007,  1.531833458884308e-007, -3.576295372524433e-010,
    -1.595049324761802e-008,  3.647098943105357e-009,  3.357608744292783e-010,
    -2.845863418986378e-010,  4.943950010300601e-011, -3.070810957053319e-012);

  Daubechies25: array [0..49] of Double =
  (  9.532010081220218e-005,  1.595911432126828e-003,  1.215286128618172e-002,
     5.517968780786707e-002,  1.638320505689675e-001,  3.250452600207450e-001,
     4.112793938419461e-001,  2.601340310680408e-001, -6.871284757950187e-002,
    -2.379223962807614e-001, -6.193379621729561e-002,  1.587722149613217e-001,
     8.354840446607072e-002, -1.064621481101881e-001, -6.965610987047755e-002,
     7.540148662568376e-002,  4.720090816788873e-002, -5.450669764609402e-002,
    -2.628596122090922e-002,  3.791358732699846e-002,  1.099028205363895e-002,
    -2.407155563373823e-002, -2.177773469222378e-003,  1.338044337843549e-002,
    -1.406736446766815e-003, -6.265462895195078e-003,  1.928235128188537e-003,
     2.349509203355524e-003, -1.302833133339296e-003, -6.363801381435396e-004,
     6.203152179445116e-004,  8.154443380499958e-005, -2.191183193706638e-004,
     2.505784570718724e-005,  5.589424549364924e-005, -1.932556858724708e-005,
    -9.031134526339836e-006,  6.357357637867466e-006,  3.700167957024616e-007,
    -1.258085327301514e-006,  2.271253510835963e-007,  1.359629720108582e-007,
    -6.121382202694482e-008, -1.846679048594542e-009,  6.561402553452289e-009,
    -1.329654731739706e-009, -1.575769720590363e-010,  1.086046415403379e-010,
    -1.787300893230113e-011,  1.067513509176335e-012);

  Daubechies26: array [0..51] of Double =
  (  6.713127351071983e-005,  1.167094049016033e-003,  9.261369452459926e-003,
     4.403489377417341e-002,  1.379137096444573e-001,  2.922422560932751e-001,
     4.056452702774954e-001,  3.105318201206985e-001,  1.254461721461498e-003,
    -2.307887593556947e-001, -1.236305221869072e-001,  1.281926839344992e-001,
     1.292275893532631e-001, -7.376813729072305e-002, -1.046356767623231e-001,
     4.937244837971600e-002,  7.529443082508006e-002, -3.779384034016670e-002,
    -4.854624598891681e-002,  2.986266501524820e-002,  2.724886613584268e-002,
    -2.218767454618790e-002, -1.255885529811589e-002,  1.466180269411168e-002,
     4.122135962895297e-003, -8.333605471314329e-003, -3.738745001447185e-004,
     3.961174882399308e-003, -6.640144547496919e-004, -1.517119009612484e-003,
     5.928021257804769e-004,  4.356755140324772e-004, -3.054388094586780e-004,
    -7.499395944891156e-005,  1.113548392405058e-004, -3.731964948727560e-006,
    -2.905978348700654e-005,  7.595893359786363e-006,  4.949803103768895e-006,
    -2.748807014083906e-006, -3.288374077110925e-007,  5.613869673485354e-007,
    -7.629712129288487e-008, -6.296408549956013e-008,  2.409675391471246e-008,
     1.533946722368951e-009, -2.670042613827367e-009,  4.794217381822202e-010,
     7.087353828290335e-011, -4.129792230626185e-011,  6.456245544944756e-012,
    -3.713633754670201e-013);

  Daubechies27: array [0..53] of Double =
  (  4.728515945306673e-005,  8.524393081240164e-004,  7.037543011339506e-003,
     3.496826876550679e-002,  1.152032703537208e-001,  2.595861216303517e-001,
     3.916309921328491e-001,  3.488908149281476e-001,  7.271946593546338e-002,
    -2.048607160733687e-001, -1.755495692431008e-001,  8.119213566812258e-002,
     1.607064832824552e-001, -2.742613961355607e-002, -1.258874512033454e-001,
     1.117186104843183e-002,  9.277097535814050e-002, -9.943867035253387e-003,
    -6.436291445145463e-002,  1.224073836524411e-002,  4.099055988664713e-002,
    -1.309030962877822e-002, -2.315001584819088e-002,  1.141762998776435e-002,
     1.107724909472278e-002, -8.186306886497104e-003, -4.145127959721101e-003,
     4.848373603751729e-003,  9.493806086921205e-004, -2.356683974474744e-003,
     1.030629167582549e-004,  9.200714012166133e-004, -2.417139318824731e-004,
    -2.742880331815954e-004,  1.428157623012879e-004,  5.416479228860859e-005,
    -5.452603280440065e-005, -2.487236509585250e-006,  1.459074287775613e-005,
    -2.758539565717111e-006, -2.586243691901908e-006,  1.155673843709720e-006,
     2.157298420224676e-007, -2.455405772341994e-007,  2.323948131194119e-008,
     2.846992248262305e-008, -9.343230103436611e-009, -9.259320095513799e-010,
     1.075944273177702e-009, -1.708035469483909e-010, -3.093582424166754e-011,
     1.565295472398123e-011, -2.330475542990664e-012,  1.292724380511056e-013);

  Daubechies28: array [0..55] of Double =
  (  3.331044123000511e-005,  6.218993647748068e-004,  5.333459230828655e-003,
     2.764264829617126e-002,  9.555693557625417e-002,  2.280867401561963e-001,
     3.712298097437536e-001,  3.751316686699133e-001,  1.415459089046001e-001,
    -1.629873734840777e-001, -2.130709375074563e-001,  2.323402917542635e-002,
     1.738126107315347e-001,  2.609710888870533e-002, -1.293138006884917e-001,
    -3.311963267513282e-002,  9.519606626417726e-002,  2.438007405228998e-002,
    -6.907397744028247e-002, -1.226259115775904e-002,  4.790499637598757e-002,
     2.438117588963363e-003, -3.064131885180438e-002,  3.133708305472644e-003,
     1.745709454444620e-002, -4.819321554812439e-003, -8.530247762218656e-003,
     4.128666784545471e-003,  3.383409129056828e-003, -2.634298922551816e-003,
    -9.619295759469540e-004,  1.326531377977092e-003,  1.001031539518552e-004,
    -5.293931387593159e-004,  8.164651312792566e-005,  1.623369372229761e-004,
    -6.296009116090445e-005, -3.470277431520087e-005,  2.574859492570050e-005,
     3.280031475408953e-006, -7.101657541258253e-006,  8.823987775424807e-007,
     1.301333676758624e-006, -4.716554598519245e-007, -1.242712713455695e-007,
     1.054055804135676e-007, -5.842390100612145e-009, -1.261576567057645e-008,
     3.566679878642807e-009,  4.910531559442040e-010, -4.297117076010421e-010,
     6.004906357907076e-011,  1.320428055354351e-011, -5.915295040927893e-012,
     8.406442740950096e-013, -4.502695013641192e-014);

  Daubechies29: array [0..57] of Double =
  (  2.346863575427791e-005,  4.532212819551641e-004,  4.032012349243343e-003,
     2.176020737112674e-002,  7.875056533495556e-002,  1.984519629309650e-001,
     3.463117738262649e-001,  3.898806024400597e-001,  2.044282755859487e-001,
    -1.089147632105576e-001, -2.333741942840082e-001, -3.939065629856281e-002,
     1.669516144387177e-001,  7.949236129997755e-002, -1.137579173049629e-001,
    -7.625860298167259e-002,  8.094413701466333e-002,  5.884595480484428e-002,
    -6.019281363498382e-002, -3.891031151933873e-002,  4.488654757800228e-002,
     2.158906092458768e-002, -3.195272869930524e-002, -9.133799719976717e-003,
     2.083874175290508e-002,  1.872649672942691e-003, -1.204996597115911e-002,
     1.228866630909230e-003,  5.989000129976236e-003, -1.803693165798036e-003,
    -2.456346906170464e-003,  1.327324912351326e-003,  7.686632080524472e-004,
    -7.076571473831614e-004, -1.414716578569598e-004,  2.907116428295632e-004,
    -1.620701501507888e-005, -9.143207801503371e-005,  2.577422657721804e-005,
     2.060045835407820e-005, -1.171908155174871e-005, -2.541090630809532e-006,
     3.359188028651565e-006, -2.141865058330067e-007, -6.346779607930216e-007,
     1.862447420289064e-007,  6.637750981241730e-008, -4.444984210563511e-008,
     7.612654420192579e-010,  5.493497660218636e-009, -1.339256988182660e-009,
    -2.423114141011283e-010,  1.702076355576445e-010, -2.079310610905801e-011,
    -5.538420775673402e-012,  2.229339693764405e-012, -3.030415636490937e-013,
     1.569205233480428e-014);

  Daubechies30: array [0..59] of Double =
  (  1.653651346925218e-005,  3.299628576293176e-004,  3.041122826294035e-003,
     1.706307534134296e-002,  6.451522322082298e-002,  1.711344568427387e-001,
     3.185429922478895e-001,  3.942631051283757e-001,  2.589726838124475e-001,
    -4.679892219920951e-002, -2.354432048918435e-001, -1.003868980351247e-001,
     1.410410181424884e-001,  1.257447087377505e-001, -8.100489337513839e-002,
    -1.111832196168217e-001,  5.146228325326329e-002,  8.679576353460498e-002,
    -3.804691595268849e-002, -6.198405322965577e-002,  3.097245477951002e-002,
     4.010169909992703e-002, -2.522490031770765e-002, -2.281392193960966e-002,
     1.914747586387463e-002,  1.081022080091293e-002, -1.301058371724290e-002,
    -3.745445614456269e-003,  7.718516866090771e-003,  4.381738791152088e-004,
    -3.910816924113878e-003,  5.963628731733372e-004,  1.643683873873266e-003,
    -6.087678255082377e-004, -5.429719201478967e-004,  3.571559729401088e-004,
     1.219636047767555e-004, -1.528565659218835e-004, -6.044564533042766e-006,
     4.937025451763011e-005, -9.473228716581479e-006, -1.156934506642857e-005,
     5.128041266546717e-006,  1.645825744769292e-006, -1.546631799321744e-006,
     7.774457740108153e-009,  3.013450316952774e-007, -7.074000025458667e-008,
    -3.368925365978656e-008,  1.842326231872540e-008,  3.926845270145394e-010,
    -2.355447404944289e-009,  4.939043752942278e-010,  1.141003745104216e-010,
    -6.690211582349795e-011,  7.071811171403347e-012,  2.290621947217472e-012,
    -8.380895349388663e-013,  1.091771147592507e-013, -5.471551682276719e-015);

  Daubechies31: array [0..61] of Double =
  (  1.165321435814672e-005,  2.400006698300906e-004,  2.288822664559868e-003,
     1.333157313005620e-002,  5.256355521933186e-002,  1.463802066838809e-001,
     2.893425781553602e-001,  3.897147171419214e-001,  3.036803052264582e-001,
     1.921153430991478e-002, -2.198784718211669e-001, -1.541340645752432e-001,
     9.912101811380680e-002,  1.590754865081172e-001, -3.530325988822104e-002,
    -1.322023525961916e-001,  1.091559922899287e-002,  1.025937697065903e-001,
    -5.755730233455301e-003, -7.609372087048412e-002,  7.736666355970219e-003,
     5.328305055474419e-002, -1.052176665771303e-002, -3.437887683418905e-002,
     1.142272499470880e-002,  1.983266227729027e-002, -1.009485080425789e-002,
    -9.829175274192616e-003,  7.437093889788914e-003,  3.900516265484583e-003,
    -4.610939304116500e-003, -1.009935636324200e-003,  2.399260291694458e-003,
    -4.524012262034694e-005, -1.031698366597207e-003,  2.426364778431980e-004,
     3.534696763222190e-004, -1.694640397769210e-004, -8.792247618903481e-005,
     7.704524909978769e-005,  1.061604715072605e-005, -2.567685121383996e-005,
     2.852836630946214e-006,  6.219217196581574e-006, -2.146169739378163e-006,
    -9.680717688047543e-007,  6.936728398227193e-007,  3.766935052738602e-008,
    -1.397190051520893e-007,  2.557482545614421e-008,  1.646363579991276e-008,
    -7.506147767384082e-009, -4.578029677632605e-010,  9.960080868754435e-010,
    -1.784768587984644e-010, -5.196478237101327e-011,  2.610715163904047e-011,
    -2.352550591155794e-012, -9.364461963390339e-013,  3.143419915209533e-013,
    -3.931119155919381e-014,  1.908751930724828e-015);

  Daubechies32: array [0..63] of Double =
  (  8.212785651997659e-006,  1.744126160609628e-004,  1.719161765387405e-003,
     1.038106730156620e-002,  4.260848563110355e-002,  1.242745691187997e-001,
     2.598685467863593e-001,  3.778198186289394e-001,  3.378620949187907e-001,
     8.529867039603245e-002, -1.885840899340125e-001, -1.961666787402615e-001,
     4.575925135522032e-002,  1.755821365176819e-001,  1.743898173300591e-002,
    -1.358368686623976e-001, -3.464477907397551e-002,  1.026945868710813e-001,
     3.139901152123263e-002, -7.739715817105097e-002, -2.095006833767659e-002,
     5.718665380321655e-002,  9.974556985156598e-003, -4.025298020095122e-002,
    -1.683099289545708e-003,  2.619933825531147e-002, -2.931598382285398e-003,
    -1.531792816636776e-002,  4.361100566103131e-003,  7.790478793840920e-003,
    -3.826556353752495e-003, -3.287492335336106e-003,  2.564835489827591e-003,
     1.038708494562116e-003, -1.389281004386447e-003, -1.563890380088740e-004,
     6.132780164841456e-004, -7.244562149856671e-005, -2.163501793926415e-004,
     7.452310320368815e-005,  5.730166999626057e-005, -3.719246297108881e-005,
    -9.150283712287061e-006,  1.289952590057336e-005, -4.498457343136124e-007,
    -3.223211527728744e-006,  8.505709915111267e-007,  5.345760886075891e-007,
    -3.030638892786253e-007, -3.537911045349176e-008,  6.339895489597473e-008,
    -8.626167743657088e-009, -7.809167123865624e-009,  3.005502396419887e-009,
     3.100230299990570e-010, -4.158559594068635e-010,  6.296590490119922e-011,
     2.307480836778207e-011, -1.011812347593169e-011,  7.605715760431834e-013,
     3.791140387120175e-013, -1.176484591660469e-013,  1.414719338154252e-014,
    -6.661666423221487e-016);


  Daubechies: array [MWaveletsDB..NWaveletsDB] of PDouble =
  ( @Daubechies1[0],  @Daubechies2[0],  @Daubechies3[0],  @Daubechies4[0],
    @Daubechies5[0],  @Daubechies6[0],  @Daubechies7[0],  @Daubechies8[0],
    @Daubechies9[0], @Daubechies10[0], @Daubechies11[0], @Daubechies12[0],
   @Daubechies13[0], @Daubechies14[0], @Daubechies15[0], @Daubechies16[0],
   @Daubechies17[0], @Daubechies18[0], @Daubechies19[0], @Daubechies20[0],
   @Daubechies21[0], @Daubechies22[0], @Daubechies23[0], @Daubechies24[0],
   @Daubechies25[0], @Daubechies26[0], @Daubechies27[0], @Daubechies28[0],
   @Daubechies29[0], @Daubechies30[0], @Daubechies31[0], @Daubechies32[0]
    );

  Symlets: array [MWaveletsSYM..NWaveletsSYM] of PDouble =
  ( @Symlets2[0], @Symlets3[0], @Symlets4[0],@Symlets5[0], @Symlets6[0],
    @Symlets7[0], @Symlets8[0]);

  Coiflets: array [MWaveletsCOIF..NWaveletsCOIF] of PDouble =
  ( @Coiflets1[0], @Coiflets2[0], @Coiflets3[0], @Coiflets4[0], @Coiflets5[0]);



var

  WaveletsInfo:
  array [1..NWaveletsDB+NWaveletsSYM+NWaveletsCOIF-MWaveletsDB-MWaveletsSYM-MWaveletsCOIF+3] of TVector;

//   -.
//   -     ,   - 
//  (  ).   
//       (  ).
//    ,    .
procedure DWT(const Signal, Filter: TVector; var Approx, Details: TVector);
var
  Buffer: TVector;
  I, I0, J, J0, J1, J2, K, L, N: Integer;
begin
  //     
  K := Length(Signal); L := Length(Filter);
  //   
  N := K; if Odd(N) then Inc(N);
  //      
  if L > N then
    begin wave_error := -3; exit; end;

  //    
  SetLength(Buffer,N+L-2);
  //    
  Move(Signal[0],Buffer[0],K*SizeOf(Signal[0]));
  //    
  if Odd(K) then Buffer[K] := (Signal[K-1]+Signal[0])/2;
  //   
  if L > 2 then Move(Signal[0],Buffer[N],(L-2)*SizeOf(Signal[0]));
  //      ,    
  //   .     ,
  //         .
  Approx := nil; Details := nil;
  //     
  N := N div 2; K := L div 2;
  SetLength(Approx,N);
  SetLength(Details,N);
  //     
  for I := 0 to Pred(N) do //    
  begin
    I0 := I * 2;
    Approx[I] := 0; Details[I] := 0;
    for J := 0 to Pred(K) do //    
    begin
      J0 := J * 2; J1 := J0 + 1; J2 := J0 + 2;
      Approx[I] := Approx[I] + Buffer[I0+J0]*Filter[J0] + Buffer[I0+J1]*Filter[J1];
      Details[I] := Details[I] + Buffer[I0+J0]*Filter[L-J1] - Buffer[I0+J1]*Filter[L-J2];
    end;
  end;
end;

//   -.
//   -      ( 
// ),   -  .  
//       
// (  ).      ,
//      OddLength  True.
//    ,    .
function IDWT(const Filter, Approx, Details: TVector; OddLength: Boolean = False): TVector;
  function FillBuf(const Source: TVector; N, Nb, L: Integer): TVector;
  begin
    SetLength(Result,L+N);
    if Nb > 0 then Move(Source[0],Result[L],Nb*SizeOf(Source[0]));
    if Nb < N then FillChar(Result[L+Nb],(N-Nb)*SizeOf(Source[0]),0);
    if L > 0 then Move(Result[N],Result[0],L*SizeOf(Source[0]));
  end;
var
  AppBuf, DetBuf: TVector;
  I, I0, I1, J, J0, J1, J2, K, L, N, Na, Nd: Integer;
begin
  //  
  AppBuf := nil; DetBuf := nil;
  //      .
  //     .
  Na := Length(Approx); Nd := Length(Details);
  //       .
  L := Length(Filter); K := Pred(L div 2); N := Max(Na,Nd);
  //    .
  AppBuf := FillBuf(Approx,N,Na,K);
  //    .
  DetBuf := FillBuf(Details,N,Nd,K);
  //     ( ).
  //      ,    !
  SetLength(Result,N*2);
  //      
  for I := 0 to Pred(N) do //    
  begin
    I0 := I * 2; I1 := I0 + 1;
    Result[I0] := 0; Result[I1] := 0;
    for J := 0 to K do //    
    begin
      J0 := J * 2; J1 := J0 + 1; J2 := J0 + 2;
      Result[I0] := Result[I0] + AppBuf[I+J]*Filter[L-J2] + DetBuf[I+J]*Filter[J1];
      Result[I1] := Result[I1] + AppBuf[I+J]*Filter[L-J1] - DetBuf[I+J]*Filter[J0];
    end;
  end;
  if OddLength then SetLength(Result,Pred(Length(Result)));
end;

//      .
function Decompose(
  const Signal: TVector;      //  
  const Mode: Integer;        //  
  const Order: Integer;       //  
  const Level: Integer        //  
  ): TDecomposition;          //  
var
  Filter: TVector;
  I: Integer;
begin
  Filter := nil;
  //if (Order < Low(WaveletsInfo)) or (Order > High(WaveletsInfo)) then
  if (Order < MinOrder[Mode]) or (Order > MaxOrder[Mode]) then
    begin wave_error:= -2; exit; end;

  //Filter := WaveletsInfo[Order];
  Filter := WaveletsInfo[StartWave[Mode]-MinOrder[Mode]+Order];
  with Result do
  begin
    WaveletMode:=mode;
    if mode=2
      then   WaveletOrder := Length(Filter) div 6
      else   WaveletOrder := Length(Filter) div 2;
    SignalLength := Length(Signal);
    Approx := Signal;
    SetLength(Details,Level);
    FillChar(Details[0],Length(Details)*SizeOf(Details[0]),0);
    for I := 0 to Pred(Level) do
      DWT(Approx,Filter,Approx,Details[I]);
  end;
end;

//  .
function Reconstruct(
  const Decomp: TDecomposition //  
  ): TVector;                  //  
var
  SynthSig: TVector absolute Result;
  Filter: TVector;
  I: Integer;
  IsOdd: Boolean;
begin
  Filter := nil;
  with Decomp do
  begin
    //if (WaveletOrder < Low(WaveletsInfo)) or (WaveletOrder > High(WaveletsInfo)) then
    if (WaveletMode<0) or (WaveletMode>2) then
      begin wave_error:=-1;exit; end;

    if (WaveletOrder < MinOrder[WaveletMode]) or (WaveletOrder > MaxOrder[WaveletMode]) then
      begin wave_error:=-2;exit; end;


    //Filter := WaveletsInfo[WaveletOrder];
    Filter := WaveletsInfo[StartWave[WaveletMode]-MinOrder[WaveletMode]+WaveletOrder];
    SynthSig := Approx;
    for I := High(Details) downto 0 do
    begin
      IsOdd := ((I > 0) and Odd(Length(Details[Pred(I)]))) or
               ((I = 0) and Odd(SignalLength));
      SynthSig := IDWT(Filter,SynthSig,Details[I],IsOdd);
    end;
    if SignalLength <> Length(SynthSig) then
      begin wave_error:=-4;exit; end;

  end;
end;

//       -.
//       .
function Denoise(
  const Decomp: TDecomposition //   
  ): TVector;                  //  
  overload;
var
  I: Integer;
begin
  with Decomp do
  begin
    for I := 0 to High(Details) do
    begin
      FillChar(Details[I,0],Length(Details[I])*SizeOf(Details[I,0]),0);
    end;
  end;
  Result := Reconstruct(Decomp);
end;

//       -.
//      Signal  
//    Order.   - ,
//       Level.
function Denoise(
  const Signal: TVector; //  
  const Mode: Integer;        //  
  const Order: Integer;  //  
  const Level: Integer   //  
  ): TVector;            //  
  overload;
begin
  Result := Denoise(Decompose(Signal,Mode, Order,Level));
end;

function GetNameWavelets(wmode:integer):string;
begin
  if (wmode < 0) or (wmode > 2) then
       begin wave_error:=-1;exit; end;

  result:=WaveletsRusName[wmode];
end;

function GetMinOrderForWavelets(wmode:integer):integer;
begin
  if (wmode<3)and(wmode>=0)
    then result:=MinOrder[wmode]
    else result:=0;
end;

function GetMaxOrderForWavelets(wmode:integer):integer;
begin
  if (wmode<3)and(wmode>=0)
    then result:=MaxOrder[wmode]
    else result:=0;
end;

function GetMaxLevelForWavelets(wmode,worder,SizeX:integer):integer;  overload;
 var
   Filter: TVector;
   r:real;
 begin
   Filter := nil;
   result:=0;
   if (wOrder < MinOrder[wMode]) or (wOrder > MaxOrder[wMode]) then
       begin wave_error:=-2;exit; end;

   try
     Filter := WaveletsInfo[StartWave[wMode]-MinOrder[wMode]+worder];
     r:=ln((sizeX/(length(filter)-1)))/ln(2);
     if r<1
      then result:=0
      else result:=trunc(r);
   except
     result:=0;
   end;
 end;

function GetMaxLevelForWavelets(wmode,worder:integer;Signal: TVector)
         :integer; overload;
begin
  result:=GetMaxLevelForWavelets(wmode,worder,length(signal));
end;

var
  I, J, K: Integer;
  P: PDouble;

initialization

  for I := 1 to NWaveletsDB do
  begin
    SetLength(WaveletsInfo[I],2*I);
    P := Daubechies[I];
    for J := 0 to Pred(2*I) do
    begin
      WaveletsInfo[I][J] := P^ * Sqrt(2);
      Inc(P);
    end;
  end;

  for I := mWaveletsSYM to NWaveletsSYM do
  begin
    K:=I+StartWave[1]-mWaveletsSYM;
    SetLength(WaveletsInfo[K],2*I);
    P := Symlets[I];
    for J := 0 to Pred(2*I) do
    begin
      WaveletsInfo[K][J] := P^ * Sqrt(2);
      Inc(P);
    end;
  end;

  for I := mWaveletsCOIF to NWaveletsCOIF do
  begin
    K:=I+StartWave[2]-mWaveletsCOIF;
    SetLength(WaveletsInfo[K],6*I);
    P := COIFlets[I];
    for J := 0 to Pred(6*I) do
    begin
      WaveletsInfo[K][J] := P^ * Sqrt(2);
      Inc(P);
    end;
  end;

end.
