library mql5_wavelet;

uses
  Math,
  WavUtils in 'WavUtils.pas';

type
  DoubleArray  = array[0..$effffff] of Double;



//________________________________________________________________________________
function wavelet_maxlevel(const wmode:integer;const worder:integer;
                          signal:DoubleArray;const sig_count:integer):integer;stdcall; export;
Var
  tmp:TVector;
  i,mode,order:integer;
Begin
      wave_error:=0;
      mode:=wmode;
      order:=worder;
      SetLength(tmp,sig_count+1);
      for i:=0 to sig_count do tmp[i]:=signal[i];
      i:=GetMaxLevelForWavelets(mode,order,tmp);
      if wave_error<0 then wavelet_maxlevel:= wave_error
                      else wavelet_maxlevel:= i;
End;
//________________________________________________________________________________
function wavelet_minorder(const wmode:integer):integer;stdcall; export;
Var
  x:integer;
Begin
      wave_error:=0;
      x:=GetMinOrderForWavelets(wmode);
      if wave_error<0 then wavelet_minorder:= wave_error
                      else wavelet_minorder:=x;
End;
//________________________________________________________________________________
function wavelet_maxorder(const wmode:integer):integer;stdcall; export;
Var
  x:integer;
Begin
      wave_error:=0;
      x:=GetMaxOrderForWavelets(wmode);
      if wave_error<0 then wavelet_maxorder:= wave_error
                      else wavelet_maxorder:=x;
End;
//________________________________________________________________________________

function wavelet_take(var signal:DoubleArray;const sig_count:integer;
                    const mode: integer;const order: integer;
                    const level:integer):integer;stdcall; export;
Var
  structsignal: TDecomposition;
  tmpsignal,tmp:TVector;
  i,n:integer;
Begin
      wave_error:=0;
      tmpsignal:=nil;
      tmp:=nil;
{      

-1  SWrongMode  = '  ';
-2  SWrongOrder = '  ';
-3  SSignalTooShort = '       ';
-4  SWrongLength = '     ';
}

      SetLength(tmpsignal,sig_count+1);
      for i:=0 to sig_count do tmpsignal[i]:=signal[i];
      structsignal:=Decompose(tmpsignal,mode,order,level);
      if wave_error<0 then
          begin wavelet_take:=wave_error; exit; end;
//______________________________________
      wave_error:=0;
      tmp:=Denoise(structsignal);
      if wave_error<0 then
          begin wavelet_take:=wave_error; exit; end;
//______________________________________
      n:=Min(Length(tmp),sig_count);
      for i:=0 to n do signal[i]:=tmp[i];
      wavelet_take:=0;
End;
//________________________________________________________________________________

exports
  wavelet_take,wavelet_minorder,wavelet_maxorder,wavelet_maxlevel;

//-----------
BEGIN
end.
